using System;
using System.Collections.Generic;
using System.Linq;
using System.IO;
using System.Threading;
using System.Diagnostics;
using System.Text.RegularExpressions;

namespace animals
{
    public struct Coord
    {
        
        public Coord(int row,
                    int col) {
            this.m_row = row;
            this.m_col = col;
        }

        #region Coord

        readonly int m_row;

        readonly int m_col;


        public int Row {
            get {
                return this.m_row;
            }
        }

        public int Col {
            get {
                return this.m_col;
            }
        }




        /* Boilerplate */

        public override string ToString() {

            string ret = string.Empty;

            ret += "row = " + this.m_row;
            ret += ", ";
            ret += "col = " + this.m_col;

            ret = "{Coord: " + ret + "}";
            return ret;

        }

        public bool Equals(Coord obj2) {

#pragma warning disable
            if (this.m_row == null) {
                if (obj2.m_row != null)
                    return false;
            }
            else {
                if (!this.m_row.Equals(obj2.m_row))
                    return false;
            }


            if (this.m_col == null) {
                if (obj2.m_col != null)
                    return false;
            }
            else {
                if (!this.m_col.Equals(obj2.m_col))
                    return false;
            }


#pragma warning restore
            return true;
        }

        public override bool Equals(object obj2) {

            var ret = (obj2 != null && obj2 is Coord);

            if (ret)
                ret = this.Equals((Coord)obj2);


            return ret;

        }

        public static bool operator ==(Coord left, Coord right) {

            var ret = left.Equals(right);
            return ret;

        }

        public static bool operator !=(Coord left, Coord right) {

            var ret = !left.Equals(right);
            return ret;

        }

        public override int GetHashCode() {

#pragma warning disable
            unchecked {
                int ret = 23;
                int temp;

                if (this.m_row != null) {
                    ret *= 31;
                    temp = this.m_row.GetHashCode();
                    ret += temp;

                }

                if (this.m_col != null) {
                    ret *= 31;
                    temp = this.m_col.GetHashCode();
                    ret += temp;

                }

                return ret;
            }
#pragma warning restore
        }

        #endregion
    }
}
