﻿
using System;
using System.Collections.Generic;
using System.Linq;
using System.IO;
using System.Threading;
using System.Diagnostics;
using System.Text.RegularExpressions;

namespace animals
{

    static class Program
    {


        static List<int> def_animals;
        static List<int> def_choices;
        static bool interactive;

        static HashSet<long> hashes_an = new HashSet<long>();
        static HashSet<long> hashes_ch = new HashSet<long>();
        const int wait = 1800; // 1800;
        static int threads = Environment.ProcessorCount;


        static void
        SolveAndTabulate(string input) {

            var watch = new Stopwatch();

            watch.Start();

            int[,] mx;
            List<Animal> ans;

            ReadInput(input, out mx, out ans);

            var mrows = mx.GetLength(0);
            var mcols = mx.GetLength(1);

            def_animals = Enumerable.Range(0, ans.Count).ToList();

            //if (version.Contains(STR_SortAnimals)) {
            //    if (version.isver(STR_EffectSort))
            //        def_animals.Sort((_an1, _an2) => -(ans[_an1].size.CompareTo(
            //                                           ans[_an2].size)));
            //    if (version.isver(STR_SizeSort))
            //        def_animals.Sort((_an1, _an2) => -(ans[_an1].effect.CompareTo(
            //                            ans[_an2].effect)));
            //    if (version.isver(STR_EffectSizeSort))
            //        def_animals.Sort((_an1, _an2) => -(ans[_an1].effectsize.CompareTo(
            //            ans[_an2].effectsize)));

            //}

            //if (!version.Contains(STR_WeightedMx)) {

            def_choices = new List<int>(mrows * mcols);


            //if (version.isver(STR_RandomHeap)) {

            //    var random = new Random(0);
            //    while (def_choices.Count < mrows * mcols / 2) {
            //        var row = random.Next(mrows);
            //        var col = random.Next(mcols);
            //        def_choices.Add(row * mcols + col);
            //    }

            //}
            //else {
            // O(n^2)
            for (int row = 0; row < mrows; row++) {
                for (int col = 0; col < mcols; col++) {
                    def_choices.Add(row * mcols + col);
                }
            }
            //}

            //if (version.isver(STR_SortHeap)) {
            //    def_choices.Sort(((_f1, _f2) => -mx[_f1 / mcols, _f1 % mcols].CompareTo(
            //                                     mx[_f2 / mcols, _f2 % mcols])));

            //}

            //}

            var final = new object();

            List<Choice> final_choices = null;
            int final_sum = 0;

            for (int thread = 0; thread < threads; thread++) {
                var id = thread;
                var start = (ThreadStart)(() =>
                {

                    List<Choice> thread_choices;
                    int thread_sum;
                    Solve(id, mx, ans, out thread_choices, out thread_sum);
                    lock (final) {
                        if (final_sum < thread_sum) {
                            final_choices = thread_choices;
                            final_sum = thread_sum;
                        }
                    }
                });
                if (thread == threads - 1) {
                    start();
                }
                else {
                    var threadobj = new Thread(start);
                    threadobj.Name = "T" + thread;
                    threadobj.Start();
                }
            }



            using (var sw = new StreamWriter("parash.out")) {

                Tabulate(sw, final_choices, watch.ElapsedMilliseconds);

            }

        }

        static void
        Tabulate(TextWriter tw, List<Choice> choices, long ms) {



            //if (choices != null) {
            tw.WriteLine(choices.Count);

            foreach (var choice in choices) {
                tw.WriteLine("{0} {1} {2}", choice.ix + 1, choice.row + 1, choice.col + 1);


            }
            //}


            if (interactive) {
                int sum = choices.Sum(_r => _r.sum);
                Console.WriteLine("{0}|{1}", sum, ms);
            }
        }

        static void
        Print(IEnumerable<int> arr) {
            foreach (var el in arr)
                Console.Write("{0,3}, ", el);
            Console.WriteLine();
        }


        static void
        Solve(int id, int[,] mx, List<Animal> ans, out List<Choice> best_choices, out int best_sum) {




            var mrows = mx.GetLength(0);
            var mcols = mx.GetLength(1);

            int[,] mmx = mx;
            mx = new int[mrows, mcols];

            var ans_ixs = new List<int>(def_animals);
            var fits_ixs = new List<int>(def_choices);
            var ans_scr = new List<int>(ans.Count);

            best_sum = 0;
            best_choices = null;

            var state = 0L;

            var watch = new Stopwatch();

            watch.Start();

            var rand = new Random(id);

            while (//true ||
                watch.ElapsedMilliseconds < wait) {

                if (!GetNewTask(rand, id, ref state, ref ans_ixs, ref fits_ixs))
                    //    break; 
                    continue;

                for (int row = 0; row < mrows; row++) {
                    for (int col = 0; col < mcols; col++) {
                        mx[row, col] = mmx[row, col];
                    }
                }


                var total_sum = 0;

                var choices = new List<Choice>();

                var by_coord = new int[mrows, mcols];


                for (int ii = 0; ii < fits_ixs.Count; ii++) {
                    var fit = fits_ixs[ii];
                    by_coord[fit / mcols, fit % mcols] = ii;
                }

                //if (version.isver(STR_Shuffle)) {
                //    Shuffle(ref fits, seed % 100);
                //}

                for (int an_ix = 0; an_ix < ans_ixs.Count; an_ix++) {
                    var an = ans[ans_ixs[an_ix]];

                    //if (version.Contains(STR_WeightedMx)) {
                    //    mmx = new int[mrows, mcols];

                    //    // O(n^4)
                    //    for (int row = 0; row < mrows; row++) {
                    //        for (int col = 0; col < mcols; col++) {
                    //            for (int row2 = 0; row2 < mrows; row2++) {
                    //                for (int col2 = 0; col2 < mcols; col2++) {
                    //                    var dist = Math.Abs(row2 - row) + Math.Abs(col2 - col) + 1;
                    //                    mmx[row2, col2] += (int)(mx[row, col] / (double)dist);
                    //                }
                    //            }
                    //        }
                    //    }

                    //    fits = new List<Fit>();
                    //    // O(n^2)
                    //    for (int row = 0; row < mrows; row++) {
                    //        for (int col = 0; col < mcols; col++) {
                    //            fits.Add(new Fit { weight = mmx[row, col], row = row, col = col });
                    //        }
                    //    }
                    //}





                    int? chosen_row = null;
                    int? chosen_col = null;

                    int sum = 0;
                    // O(n^2*a)
                    for (int fit_ix = 0; fit_ix < fits_ixs.Count; fit_ix++) {


                        var fit = fits_ixs[fit_ix];
                        var frow = fit / mcols;
                        var fcol = fit % mcols;

                        //if (version.isver(STR_AdjustsCenter)) {
                        //    frow -= an.center_x;
                        //    fcol -= an.center_y;

                        //    if (frow < 0)
                        //        continue;
                        //    if (fcol < 0)
                        //        continue;
                        //}


                        if (frow + an.height - 1 >= mrows)
                            continue;
                        if (fcol + an.width - 1 >= mcols)
                            continue;

                        chosen_row = frow;
                        chosen_col = fcol;

                        for (int row = 0; row < an.height; row++) {
                            for (int col = 0; col < an.width; col++) {
                                if (an.shape[row, col] == 0)
                                    continue;
                                if (mx[row + frow, col + fcol] < an.safety) {
                                    chosen_row = null;
                                    break;
                                }

                            }
                            if (chosen_row == null)
                                break;
                        }

                        if (chosen_row == null)
                            continue;

                        for (int row = 0; row < an.height; row++) {
                            for (int col = 0; col < an.width; col++) {
                                if (an.shape[row, col] == 0)
                                    continue;

                                int mrow = row + frow;
                                int mcol = col + fcol;

                                //sum += animal.safety;
                                sum += mx[mrow, mcol];
                                mx[mrow, mcol] /= an.effect;


                                //// restore fits partial sortedness
                                //if (version.isver(STR_SortHeap)) {
                                //    var ix = by_coord[mrow, mcol];
                                //    int ii;
                                //    var temp_w = mx[mrow, mcol];

                                //    Func<int, int> get_weight = _ix =>
                                //        {
                                //            var _tf = fits_ixs[_ix];
                                //            var _tr = _tf / mcols;
                                //            var _tc = _tf % mcols;
                                //            return mx[_tr, _tc];
                                //        };

                                //    if (ix < fits_ixs.Count - 1 && temp_w < get_weight(ix)) {
                                //        int tf = 0, tr = 0, tc = 0;
                                //        for (ii = ix + 1; ii < fits_ixs.Count; ii++) {

                                //            if (get_weight(ii) <= temp_w) {
                                //                tf = fits_ixs[ii];
                                //                tr = tf / mcols;
                                //                tc = tf % mcols;
                                //                break;
                                //            }
                                //        }

                                //        fits_ixs.Insert(ii, tf);
                                //        fits_ixs.RemoveAt(ix);

                                //        for (int jj = ii; jj < fits_ixs.Count; jj++) {
                                //            tf = fits_ixs[jj];
                                //            tr = tf / mcols;
                                //            tc = tf % mcols;
                                //            by_coord[tr, tc] = jj;
                                //        }
                                //    }

                                //}

                            }
                        }



                        if (chosen_row != null) {
                            break;
                        }
                    }

                    if (chosen_row == null) {
                        continue;
                    }


                    choices.Add(new Choice
                    {
                        ix = an.ix,
                        row = chosen_row.Value,
                        col = chosen_col.Value,
                        sum = sum
                    });
                    total_sum += sum;


                }

                if (total_sum >= best_sum) {
                    best_sum = total_sum;
                    best_choices = choices;

                }
            }
        }

        //static void
        //Shuffle2(Random rand, List<int> input, List<int> scratch,
        //         int percent, bool stepwise, out long hash) {


        //    for (int i = scratch.Count; i > 1; i--) {
        //        // Pick random element to swap.
        //        int j = rand.Next(i);
        //        // Swap.
        //        var tmp = scratch[j];
        //        scratch[j] = scratch[i - 1];
        //        scratch[i - 1] = tmp;
        //    }

        //    hash = 0;
        //    for (int ii = 0; ii < input.Count; ++ii) {
        //        hash = unchecked(hash * 314159 + scratch[ii]);
        //    }
        //}

        static void Shuffle(Random rand, List<int> input, List<int> scratch,
                 long degree, bool stepwise, out long hash) {
            Shuffle1(rand, input, scratch,
                  degree, stepwise, out hash);
        }



        // shuffles up to a specific degree
        static void
        Shuffle1(Random rand, List<int> input, List<int> scratch,
                 long degree, bool stepwise, out long hash) {

            // stepwise: probability of ii being moved: prob*ii/len (grows linearly with ii)
            // probability of ii being moved +dx positions: ~ (ln len - ln dx)/len
            // http://www.danmorgan.net/programming/php-programming/weighted-random-and-weighted-shuffle/

            var len = input.Count;
            var prob = degree / (double)long.MaxValue;
            var step = prob / len;

            if (scratch.Count != input.Count) {
                scratch.Capacity = input.Count;

                scratch.Clear();

                scratch.Capacity = input.Count;

                scratch.AddRange(input);
            }


            var dist = len; // (int)(Math.Sqrt(len) * 5  * prob);

            var seen = new HashSet<int>();
            for (int ii = 0; ii < len; ii++) {
                if (seen.Contains(ii))
                    continue;
                var rnd = rand.NextDouble();

                if (rnd > (stepwise ? step * (ii + 1) : prob)) {
                    scratch[ii] = input[ii];
                    continue;

                }

                var new_ix = ii;



                var dx = rand.Next(rand.Next(dist) + 1);
                dx *= (rand.Next() % 2) == 0 ? 1 : -1;
                new_ix = ii + dx;

                if (new_ix >= len)
                    new_ix %= len;

                if (new_ix < 0)
                    new_ix = len - (Math.Abs(new_ix) % len) - 1;

                if (new_ix == ii) {

                    scratch[ii] = input[ii];
                    continue;


                }

                try {
                    scratch[ii] = input[new_ix];
                    scratch[new_ix] = input[ii];
                }
                catch {
                    Shuffle1(rand, input, scratch, degree + 1, stepwise, out hash);
                    return;
                    //Console.WriteLine("CAUGHT: {0} {3} {1} {2}", ii, scratch.Count, input.Count, new_ix);
                    //Console.ReadLine();
                    //throw;

                }

                seen.Add(new_ix);

                //lst2.RemoveAt(ii);
                //if (ii < new_ix)
                //    --new_ix;
                //lst2.Insert(new_ix, input[ii]);



            }

            hash = 0;
            for (int ii = 0; ii < len; ++ii) {
                hash = unchecked(hash * 314159 + scratch[ii]);
            }
        }


        static bool
        GetNewTask(Random rand, int id, ref long state, ref List<int> animals, ref List<int> choices) {


            bool shuf_animals = true;
            bool shuf_choices = true;

            bool stepwise = true;
            var jump = 1.01;
            var step = id == 0 ? 100000 : 10000;
            long degree_choices, degree_animals;
            int tries = 0;

            while (true) {
                if (state < 0)
                    return false;


                ++tries;
                if (tries > 1000)
                    // spin around
                    return false;

                if (id == 0) {
                    if (state == 0) {

                        degree_choices = 0;

                        degree_animals = 0;
                    }
                    else {
                        degree_choices = long.MaxValue / (threads + 1) + state;
                        degree_animals = degree_choices;
                    }

                }
                else {
                    degree_choices = id * (long.MaxValue / (threads + 1)) + state;
                    degree_animals = degree_choices;
                }

                state += step;

                long hash_an, hash_ch;
                hash_an = hash_ch = 0;

                if (shuf_animals) {
                    Shuffle(rand, def_animals, animals, degree_animals, stepwise, out hash_an);

                }

                if (shuf_animals = hashes_an.Contains(hash_an)) {

                    state = (long)(state * jump);

                    continue;
                }

                if (shuf_choices) {
                    state = (long)(state * jump); // state += step;
                    Shuffle(rand, def_choices, choices, degree_choices, stepwise, out hash_ch);
                }

                if (shuf_choices = hashes_ch.Contains(hash_ch)) {

 
                    state = (long)(state * jump);

                    continue;

                }


                lock (hashes_an) {
                    lock (hashes_ch) {
                        if (!(shuf_animals = hashes_an.Contains(hash_an)) &&
                           !(shuf_choices = hashes_ch.Contains(hash_ch))) {


                            hashes_an.Add(hash_an);
                            hashes_ch.Add(hash_ch);
                            return true;
                        }
                    }
                }


                state = (long)(state * jump);

            }
        }


        // fixme: variable storage types

        static int
        Main(string[] args) {

            interactive = File.Exists("2012-11-05-18-52-21");

            string input;

            if (args.Length == 0)
                input = "parash.in";
            else
                input = args[0];

            //interactive = true;

            SolveAndTabulate(input);

            return 0;

        }

        //=========================



        static void
        ReadInput(
            string input,
            out int[,] mx,
            out List<Animal> animals) {


            using (var sr = new StreamReader(input)) {

                var temp = default(string[]);

                Action<bool> put =
                    space => temp = space ? sr.ReadLine().Split(' ')
                                          : sr.ReadLine().ToCharArray().Select(_c => _c.ToString()).ToArray();

                Func<int, int> get =
                    _ix => int.Parse(temp[_ix]);

                Func<int[,], int, int> stuff =
                    (_arr, _row) =>
                    {
                        var _sum = 0;
                        for (int _col = 0; _col < _arr.GetLength(1); _col++) {
                            _sum += _arr[_row, _col] = get(_col);

                        }
                        return _sum;
                    };

                // header
                put(true);

                var mrows = get(0);
                var mcols = get(1);
                var ans_cnt = get(2);

                mx = new int[mrows, mcols];
                animals = new List<Animal>(ans_cnt);

                // matrix
                for (int row = 0; row < mrows; row++) {

                    put(true);
                    stuff(mx, row);

                }


                for (int an = 0; an < ans_cnt; an++) {

                    // animal header
                    put(true);

                    int arows = get(0);
                    int acols = get(1);
                    int effect = get(2);
                    int safety = get(3);
                    int[,] shape = new int[arows, acols];
                    int sum = 0;

                    // animal shape
                    for (int row = 0; row < arows; row++) {

                        put(false);
                        sum += stuff(shape, row);

                    }

                    //if (version.isver(STR_AdjustsCenter))
                    //    for (int dx = 0; ; dx++) {
                    //        for (int dy = 0; ; dy++) {
                    //            if (dy + dx == 0)
                    //                continue;

                    //            var mx1 = center_x + dx;
                    //            var mx2 = center_x - dx;
                    //            var my1 = center_y + dy;
                    //            var my2 = center_y - dy;


                    //            if (mx1 < arows) {
                    //                if (shape[mx1, center_y] != 0) {
                    //                    center_x = mx1;
                    //                    break;
                    //                }
                    //            }
                    //            if (mx2 >= 0) {
                    //                if (shape[mx2, center_y] != 0) {
                    //                    center_x = mx2;
                    //                    break;
                    //                }
                    //            }
                    //            if (my1 < acols) {
                    //                if (shape[center_x, my1] != 0) {
                    //                    center_y = my1;
                    //                    break;
                    //                }
                    //            }
                    //            if (my2 >= 0) {
                    //                if (shape[center_x, my2] != 0) {
                    //                    center_y = my2;
                    //                    break;
                    //                }
                    //            }


                    //            if (mx1 < arows && my1 < acols) {
                    //                if (shape[mx1, my1] != 0) {
                    //                    center_x = mx1;
                    //                    center_y = my1;
                    //                    break;
                    //                }
                    //            }
                    //            if (mx2 >= 0 && my1 < acols) {
                    //                if (shape[mx2, my1] != 0) {
                    //                    center_x = mx2;
                    //                    center_y = my1;
                    //                    break;
                    //                }
                    //            }
                    //            if (mx1 < arows && my2 > 0) {
                    //                if (shape[mx1, my1] != 0) {
                    //                    center_x = mx1;
                    //                    center_y = my2;
                    //                    break;
                    //                }
                    //            }
                    //            if (mx2 >= 0 && my2 > 0) {
                    //                if (shape[mx2, my2] != 0) {
                    //                    center_x = mx2;
                    //                    center_y = my2;
                    //                    break;
                    //                }
                    //            }

                    //        }

                    //        if (shape[center_x, center_y] != 0)
                    //            break;
                    //    }

                    animals.Add(new Animal
                    {
                        ix = an,
                        shape = shape,
                        effect = effect,
                        safety = safety,
                        height = shape.GetLength(0),
                        width = shape.GetLength(1),
                    });

                }


            }

        }


    }
}